算法整理——【贪心算法练习(2)】

我们继续对贪心算法进行练习,积累题目经验。

一、根据身高重建队列

题目为406. 根据身高重建队列 - 力扣(LeetCode),假设有打乱顺序的一群人站成一个队列,数组 people 表示队列中一些人的属性(不一定按顺序)。每个 people[i] = [hi, ki] 表示第 i 个人的身高为 hi ,前面正好有 ki 个身高大于或等于 hi 的人。请你重新构造并返回输入数组 people 所表示的队列。返回的队列应该格式化为数组 queue ,其中 queue[j] = [hj, kj] 是队列中第 j 个人的属性(queue[0] 是排在队列前面的人)。

本题有两个维度的参数:身高和排位。我们遇到两个维度权衡的时候,一定要先确定一个维度,再确定另一个维度。比如这道题,我们可以先按照身高进行排序,身高从高到低排序,身高相同则排位靠前的排在前面。此时,只需要把排序为k的人插入第k个位置即可,因为此时身高已经从高到低排序了,站在他前面的就是比他高的。

此处排序函数sort需要自定义排序规则。我们定义cmp函数,为static bool cmp(),参数类型为const vector<int>&。如果符合排序要求则返回1,不符合则返回0。

完整代码为:

cpp 复制代码
class Solution {
public:
    static bool cmp(const vector<int>& a, const vector<int>& b)
    {
        if(a[0]>b[0])
        {
            return 1;
        }
        else if(a[0]<b[0])
        {
            return 0;
        }
        else
        {
            return a[1]<b[1];
        }
    }
    vector<vector<int>> reconstructQueue(vector<vector<int>>& people) {
        sort(people.begin(),people.end(),cmp);
        vector<vector<int>> ret;
        for(int i = 0; i<people.size(); i++)
        {
            int pos = people[i][1];
            ret.insert(ret.begin()+pos, people[i]);
        }
        return ret;
    }
};

二、单调递增的数字

题目为738. 单调递增的数字 - 力扣(LeetCode),当且仅当每个相邻位数上的数字 x 和 y 满足 x <= y 时,我们称这个整数是单调递增的。给定一个整数 n ,返回 小于或等于 n 的最大数字,且数字呈单调递增。

思路简单来说就是遍历每一位,如果前一位小于后一位则满足条件,前一位大于后一位则需要前一位减一,后一位变成9。但有几点需要注意的地方,首先是遍历顺序,如果从前往后遍历,例如332,遍历到3>2时,会发现需要把3减到2,2变为9,结果变成了329。这并不符合要求。我们应该从后往前遍历。然后还有一个问题,比如我们目前的思路时从后往前遍历,前一位大于后一位则前一位--,后一位变成9,此时如果遇到101这种数,会处理得到91。这并不对,我们应该把接收减一操作的数的后面的数都变成9这样才是最大的结果。所以我需要进行修改,对前一位大于后一位情况出现时,对前一位的位置进行记录,然后后面统一把该位以后的所有位都改为9即可。

另外,本题使用了to_string()函数实现Int类型转string,以及stoi()函数实现string类型转int类型。

完整代码如下:

cpp 复制代码
class Solution {
public:
    int monotoneIncreasingDigits(int n) {
        string str = to_string(n);
        int pos = -1;
        for(int i = str.size()-1; i>0; i--)
        {
            if(str[i]<str[i-1])
            {
                pos = i;
                str[i-1]--;
            }
        }
        if(pos!=-1)
        {
            for(int i = pos; i<str.size(); i++)
            {
                str[i]='9';
            }
        }
        return stoi(str);
    }
};

说明:本文为作者整理知识点用于复习巩固,参考了代码随想录的讲解,有问题可以联系作者欢迎讨论~

相关推荐
海上小飞龙4 小时前
【KMP算法-下篇】同一道题:Java 库函数 2600 微秒,手写 KMP 16 微秒
java·开发语言·算法
青少儿编程课堂5 小时前
后缀自动机解析:本质不同子串与最长重复片段统计
c++·python·算法·bfs·信息学竞赛
朝朝辞暮i5 小时前
C++ 第 12 课:局部变量、作用域、变量生命周期
开发语言·c++·算法
乐迪信息6 小时前
港口船舶逆行怎么管?AI防爆摄像机搭载智能检测算法
大数据·人工智能·深度学习·算法·计算机视觉
Sirens.7 小时前
Java并发锁详解:六类锁策略与 synchronized 底层原理
java·前端·算法
和裕7 小时前
全纸结构重型纸箱能否满足 1 吨以上设备出口熏蒸豁免要求?通关合规性全解析
大数据·运维·网络·人工智能·算法
tangguofeng8 小时前
不带头结点的链队操作集(不含InitFlag)(C语言版)
算法
苏打豆9 小时前
CRISP源码阅读——基于ROS2力矩反馈控制器与速度加速度零空间
c++·线性代数·算法·矩阵·机器人
蛋蛋的就会顺顺的9 小时前
hot100——矩阵
java·数据结构·算法·leetcode·力扣
老歌老听老掉牙10 小时前
麻花钻切屑形态演变的力学机制与临界条件分析
python·算法·钻头